
#include <stdlib.h>
#include <math.h>

#include "config.h"
#include "scan_server.h"

static int convert(int v)
{
  int i;

  /* Arbitrary time-consuming calculation: */
  for (i = 0; i < 1000; i++) {
    v = ((v * v) + v) % 10;
  }

  return v;
}

static int deconvert(int v)
{
  return convert(v);
}

/* **************************************** */

/* PART 2 CHANGE: this function, plus uses of `tmp' */
int *tmp;
void prepate_temps(int n)
{ 
  tmp = (int *)malloc(n * sizeof(int));
}

tally_t init()
{
  return 0;
}

tally_t accum(tally_t tally, int i, data_t *myArray)
{
  tmp[i] = convert(myArray[i]);
  return tally + tmp[i];
}

tally_t combine(tally_t tally1, tally_t tally2)
{
  return tally1 + tally2;
}

tally_t scanGen(tally_t tally, int i, 
                data_t *myArray, result_t *myResult)
{
  tally += tmp[i];
  myResult[i] = deconvert(tally);
  return tally;
}
